package com.usky.dxtop.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.usky.dxtop.model.Order;
import com.usky.dxtop.service.vo.OrderReport;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;


/**
 * <p>
 * 订单表 Mapper 接口
 * </p>
 *
 * @author yq
 * @since 2021-08-26
 */
public interface OrderMapper extends BaseMapper<Order> {


    /**
     *
     * @param page
     * @param endTime
     * @return
     */
    Page<OrderReport> getCountByDay(IPage<OrderReport> page,
                                    @Param("startTime") Date startTime,
                                    @Param("endTime") Date endTime);


    /**
     * 周报
     * @param startTime
     * @param endTime
     * @return
     */
    Page<OrderReport> getCountByWeek(IPage<OrderReport> page,
                                        @Param("startTime") Date startTime,
                                           @Param("endTime") Date endTime);


    /**
     * 月报
     * @param startTime
     * @param endTime
     * @return
     */
    Page<OrderReport> getCountByMonth(IPage<OrderReport> page,
                                      @Param("startTime") Date startTime,
                                      @Param("endTime") Date endTime);


    /**
     * 年报
     * @param startTime
     * @param endTime
     * @return
     */
    Page<OrderReport> getCountByYear(IPage<OrderReport> page,
                                     @Param("startTime") Date startTime,
                                     @Param("endTime") Date endTime);


}
